'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _reactInlineBlock = require('react-inline-block');

var _reactInlineBlock2 = _interopRequireDefault(_reactInlineBlock);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _toMoment2 = require('./toMoment');

var _toMoment3 = _interopRequireDefault(_toMoment2);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

var _bemFactory = require('./bemFactory');

var _bemFactory2 = _interopRequireDefault(_bemFactory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ARROWS = _defineProperty({}, -1, _react2.default.createElement(
  'svg',
  { fill: '#000000', height: '24', viewBox: '0 0 24 24', width: '24', xmlns: 'http://www.w3.org/2000/svg' },
  _react2.default.createElement('path', { d: 'M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z' }),
  _react2.default.createElement('path', { d: 'M0-.5h24v24H0z', fill: 'none' })
));

var bem = (0, _bemFactory2.default)('react-date-picker__navigation');

var NavigationView = function (_Component) {
  _inherits(NavigationView, _Component);

  function NavigationView(props) {
    _classCallCheck(this, NavigationView);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(NavigationView).call(this, props));

    _this.state = {
      viewDate: props.defaultViewDate
    };
    return _this;
  }

  _createClass(NavigationView, [{
    key: 'prepareViewDate',
    value: function prepareViewDate(props) {
      return props.viewDate === undefined ? this.state.viewDate : props.viewDate;
    }
  }, {
    key: 'render',
    value: function render() {

      var child = _react2.default.Children.toArray(this.props.children)[0];
      var childProps = child.props || {};

      var cloneProps = (0, _objectAssign2.default)({}, this.props);

      delete cloneProps.style;
      delete cloneProps.className;

      var viewDate = this.prepareViewDate({
        viewDate: this.props.viewDate !== undefined ? this.props.viewDate : childProps.viewDate
      });

      var view = _react2.default.cloneElement(child, (0, _objectAssign2.default)(cloneProps, {
        viewDate: viewDate
      }));

      var props = this.p = (0, _objectAssign2.default)({}, view.props);

      props.viewMoment = this.toMoment(viewDate);

      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({
          column: true,
          alignItems: 'stretch'
        }, props),
        this.renderNavigation(),
        view
      );
    }
  }, {
    key: 'toMoment',
    value: function toMoment(value, props) {
      props = props || this.p;

      return (0, _toMoment3.default)(value, {
        locale: props.locale,
        dateFormat: props.dateFormat
      });
    }
  }, {
    key: 'renderNavigation',
    value: function renderNavigation() {
      if (this.props.renderNavigation) {
        return this.props.renderNavigation({
          viewDate: props.viewDate
        });
      }

      return _react2.default.createElement(
        _reactFlex.Flex,
        { row: true },
        this.renderNavBefore(),
        _react2.default.createElement(
          _reactFlex.Item,
          { style: { textAlign: 'center' } },
          this.renderHeaderDate()
        ),
        this.renderNavAfter()
      );
    }
  }, {
    key: 'renderNavBefore',
    value: function renderNavBefore() {
      return this.renderNav(-1);
    }
  }, {
    key: 'renderNavAfter',
    value: function renderNavAfter() {
      return this.renderNav(1);
    }
  }, {
    key: 'renderNav',
    value: function renderNav(dir) {
      var className = bem('arrow--' + (dir == -1 ? 'prev' : 'next'));

      return _react2.default.createElement(
        _reactInlineBlock2.default,
        { className: className, onClick: this.onNavClick.bind(this, dir) },
        ARROWS[dir]
      );
    }
  }, {
    key: 'onNavClick',
    value: function onNavClick(dir) {

      var props = this.p;
      var viewMoment = props.viewMoment;

      var dateMoment = this.toMoment(viewMoment).add(dir, 'month');
      var timestamp = +dateMoment;

      this.onViewDateChange({
        dateMoment: dateMoment,
        timestamp: timestamp
      });
    }
  }, {
    key: 'renderHeaderDate',
    value: function renderHeaderDate() {
      var props = this.p;
      var moment = props.viewMoment;

      if (this.props.renderHeaderDate) {
        return this.props.renderHeaderDate(moment);
      }

      return moment.format(props.headerDateFormat);
    }
  }, {
    key: 'onViewDateChange',
    value: function onViewDateChange(_ref) {
      var dateMoment = _ref.dateMoment;
      var timestamp = _ref.timestamp;

      if (this.props.viewDate === undefined) {
        this.setState({
          viewDate: timestamp
        });
      }

      this.props.onViewDateChange({ dateMoment: dateMoment, timestamp: timestamp });
    }
  }]);

  return NavigationView;
}(_reactClass2.default);

exports.default = NavigationView;


NavigationView.defaultProps = {
  headerDateFormat: 'MMM YYYY',

  onViewDateChange: function onViewDateChange() {}
};

NavigationView.propTypes = {};